{-# LANGUAGE ImportQualifiedPost #-}
{-# LANGUAGE OverloadedStrings #-}

module Main (main) where

-- import Compiler.ExeGen
import Compiler.LLVMGen
import Data.Text.Lazy qualified as L
import Data.Text.Lazy.IO qualified as T
import Parser.Expr
import System.Environment
import Types.Expr

getRight :: ParseResult -> Expr
getRight (Right r) = r

main :: IO ()
main = do
  fileName <- fmap head getArgs
  contents <- readFile fileName
  T.putStrLn "- Parsing file..."
  let parsed = getRight (parseExpr contents)
  T.putStrLn "- Generating LLVM to './a.out.ll'..."
  let llvm = llvmGen parsed
  writeFile "a.out.ll" (L.unpack llvm)
  T.putStrLn "- Done."
